<?php
namespace app\admin\controller;
use think\Controller;
use think\Db;
use org\Upload;
// +----------------------------------------------------------------------
// | ThinkPHP [ WE CAN DO IT JUST THINK ]
// +----------------------------------------------------------------------
// | Copyright (c) 2022 All rights reserved.
// +----------------------------------------------------------------------
// | Author: 作者@梦雨 <50361804@qq.com>
// +----------------------------------------------------------------------
class Up extends Controller
{
    
    public function _initialize()
    {
        if (socha(dengji(user('userid'),'config'), 3)==0 && !session('userid_admin')) {
            $this->error('您当前等级不能上传附件');
        }
    }
    // 提取数字
    public function findNum($str=''){
        $str=trim($str);
        if(empty($str)){return '';}
        $temp=array('1','2','3','4','5','6','7','8','9','0');
        $result='';
        for($i=0;$i<strlen($str);$i++){
            if(in_array($str[$i],$temp)){
                $result.=$str[$i];
            }
        }
        return $result;
    }
    // 保存附件信息
    public function enclosure($sha1,$md5,$size,$name,$ext,$type,$path,$savename){
        $data['sha1'] = $sha1;
        $data['md5'] = $md5;
        $data['time'] = time();
        $data['uid'] = user('userid');
        $data['size'] = $size;
        $data['name'] = $name;
        $data['ext'] = $ext;
        $data['savepath'] = $path;
        $data['savename'] = $savename;
        $data['mime'] = $type;
        if (preg_replace("/\\/(.*)/", "", $data['mime']) == "image") {
            $data['img'] = 1;
        } else {
            $data['img'] = 0;
        }
        Db::name('file')->insert($data);
    }
    // 图片检查是否是木马
    public function checkHex($img)
    {
        $status = 0;
        //文件没问题
        if (file_exists($img)) {
            $resource = fopen($img, 'rb');
            $fileSize = filesize($img);
            fseek($resource, 0);
            if ($fileSize > 512) {
                $hexCode = bin2hex(fread($resource, 512));
                fseek($resource, $fileSize - 512);
                $hexCode .= bin2hex(fread($resource, 512));
            } else {
                $hexCode = bin2hex(fread($resource, $fileSize));
            }
            fclose($resource);
            if (preg_match("/(3c25.*?28.*?29.*?253e)|(3c3f.*?28.*?29.*?3f3e)|(3C534352495054)|(2F5343524950543E)|(3C736372697074)|(2F7363726970743E)/is", $hexCode)) {
                $status = 5;//文件有毒
            }
        } else {
            $status = -1;//文件没有上传
        }
        return $status;
    }
    // 图片上传处理编辑器
    public function pic()
    {
        hook('php_admin_up_pic');
        foreach (array_keys(request()->file()) as $value){
            if ($this->checkHex($_FILES[$value]['tmp_name'])==5) {
                return array('code' => 500, 'msg' => "当前图片有问题");
            } 
            if ($this->findNum($value)) {
                $v = $this->findNum($value)-1;
            } else {
                $v = 0;
            }
            $file = request()->file($value);
            $md5 = $file->hash('md5');
            $n = Db::name('file')->where('md5', $md5)->find();
            if (empty($n)) {
                if (set('qiniu')==1) {
                    // 七牛
                    $driverConfig = ['secrectKey' => set('secrectKey'), 'accessKey' => set('accessKey'), 'domain' => set('qiniudomain'), 'bucket' => set('qiniubucket')];
                    $setting['exts'] = explode(',', 'png,jpg,jpeg,gif,bmp');
                    $setting['maxSize'] = 50 * 1024 * 1024;
                    $Upload = new Upload($setting, 'Qiniu', $driverConfig);
                    $info = $Upload->uploadOne($_FILES[$value]);
                    if ($info) {
                        $data[$v]['url'] = $info['url'];
                        $data[$v]['alt'] = $info['name'];
                        $data[$v]['href'] = '';
                        $data[$v]['getInfo'] = $info;
                        $this->enclosure(
                            $info['sha1'],
                            $info['md5'],
                            $info['size'],
                            $info['name'],
                            $info['ext'],
                            $info['type'],
                            $info['url'],
                            $info['savename']
                        );
                    } else {
                        // 上传失败获取错误信息
                        return $Upload->getError();
                    }
                }else{
                    // 本地
                    $info = $file->validate(['size' => 10 * 1024 * 1024, 'ext' => 'png,jpg,jpeg,gif,bmp,flv'])->move(ROOT_PATH . DS . 'uploads');
                    if ($info) {
                        $dataurl = DS . 'uploads' . DS . $info->getSaveName();
                        $data[$v]['url'] = $dataurl;
                        $data[$v]['alt'] = $info->getInfo()['name'];
                        $data[$v]['href'] = '';
                        $data[$v]['getInfo'] = $info->getInfo();
                        $this->enclosure(
                            $info->sha1(),
                            $info->md5(),
                            $info->getSize(),
                            $info->getInfo()['name'],
                            $info->getExtension(),
                            $info->getInfo()['type'],
                            $dataurl,
                            $info->getFilename()
                        );
                    } else {
                        // 上传失败获取错误信息
                        return $file->getError();
                    }
                }
                
            } else {
                $data[$v]['url'] = $n['savepath'];
                $data[$v]['alt'] = $n['name'];
                $data[$v]['href'] = '';
                $data[$v]['getInfo'] = $n;
            }
        }
        return json(array('errno' => 0, 'data' => $data));
    }
    // 视频上传处理编辑器
    public function video()
    {
        hook('php_admin_up_video');
        if ($this->checkHex($_FILES['fileName']['tmp_name'])==5) {
            return array('code' => 500, 'msg' => "当前视频有问题");
        } 
        $file = request()->file('fileName');
        $md5 = $file->hash('md5');
        $n = Db::name('file')->where('md5', $md5)->find();
        if (empty($n)) {
            if (set('qiniu')==1) {
                // 七牛
                $driverConfig = ['secrectKey' => set('secrectKey'), 'accessKey' => set('accessKey'), 'domain' => set('qiniudomain'), 'bucket' => set('qiniubucket')];
                $setting['exts'] = explode(',', 'mp4');
                $setting['maxSize'] = 50 * 1024 * 1024;
                $Upload = new Upload($setting, 'Qiniu', $driverConfig);
                $info = $Upload->uploadOne($_FILES['fileName']);
                if ($info) {
                    $data['url'] = $info['url'];
                    $data[$v]['getInfo'] = $info;
                    $this->enclosure(
                        $info['sha1'],
                        $info['md5'],
                        $info['size'],
                        $info['name'],
                        $info['ext'],
                        $info['type'],
                        $info['url'],
                        $info['savename']
                    );
                } else {
                    // 上传失败获取错误信息
                    return $Upload->getError();
                }
            }else{
                // 本地
                $info = $file->validate(['size' => 10 * 1024 * 1024, 'ext' => 'mp4'])->move(ROOT_PATH . DS . 'uploads');
                if ($info) {
                    $dataurl = DS . 'uploads' . DS . $info->getSaveName();
                    $data['url'] = $dataurl;
                    $data['getInfo'] = $info->getInfo();
                    $this->enclosure(
                        $info->sha1(),
                        $info->md5(),
                        $info->getSize(),
                        $info->getInfo()['name'],
                        $info->getExtension(),
                        $info->getInfo()['type'],
                        $dataurl,
                        $info->getFilename()
                    );
                } else {
                    // 上传失败获取错误信息
                    return $file->getError();
                }
            }
        } else {
            $data['url'] = $n['savepath'];
            $data['getInfo'] = $n;
        }
        return json(array('errno' => 0, 'data' => $data));
    }
    // 上传其他
    public function up()
    {
        hook('php_admin_up_up');
        if ($this->checkHex($_FILES['file']['tmp_name'])==5) {
            return array('code' => 0, 'msg' => "当文件有问题");
        } 
        $file = request()->file('file');
        $md5 = $file->hash('md5');
        $n = Db::name('file')->where('md5', $md5)->find();
        if (empty($n)) {
            if (set('qiniu')==1) {
                // 七牛
                $driverConfig = ['secrectKey' => set('secrectKey'), 'accessKey' => set('accessKey'), 'domain' => set('qiniudomain'), 'bucket' => set('qiniubucket')];
                $setting['exts'] = explode(',', set('exp'));
                $setting['maxSize'] = 50 * 1024 * 1024;
                $Upload = new Upload($setting, 'Qiniu', $driverConfig);
                $info = $Upload->uploadOne($_FILES['file']);
                if ($info) {
                    $data['url'] = $info['url'];
                    $data[$v]['getInfo'] = $info;
                    $this->enclosure(
                        $info['sha1'],
                        $info['md5'],
                        $info['size'],
                        $info['name'],
                        $info['ext'],
                        $info['type'],
                        $info['url'],
                        $info['savename']
                    );
                } else {
                    return array('code' => 0, 'msg' => $Upload->getError());
                }
            }else{
                // 本地
                $info = $file->validate(['size' => 10 * 1024 * 1024, 'ext' => set('exp')])->move(ROOT_PATH . DS . 'uploads');
                if ($info) {
                    $dataurl = DS . 'uploads' . DS . $info->getSaveName();
                    $data['url'] = $dataurl;
                    $data['getInfo'] = $info->getInfo();
                    $this->enclosure(
                        $info->sha1(),
                        $info->md5(),
                        $info->getSize(),
                        $info->getInfo()['name'],
                        $info->getExtension(),
                        $info->getInfo()['type'],
                        $dataurl,
                        $info->getFilename()
                    );
                } else {
                    // 上传失败获取错误信息
                    return array('code' => 0, 'msg' => $file->getError());
                }
            }
        } else {
            $data['url'] = $n['savepath'];
            $data['getInfo'] = $n;
        }
        return json(array('code' => 1, 'msg' => '上传成功', 'data' => $data));
    }
}